| The Gaudi Framework v30r0 (c919700c)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Member Functions | Private Attributes | List of all members
TimelineSvc Class Reference

`#include <src/TimelineSvc.h>`

Inheritance diagram for TimelineSvc:
[legend]
Collaboration diagram for TimelineSvc:
[legend]

## Public Member Functions
StatusCode | initialize () override
StatusCode | reinitialize () override
StatusCode | finalize () override
void | registerTimelineEvent (const TimelineEvent &) override
void | getTimelineEvent (TimelineEvent &) const override
bool | isEnabled () const override
| ~TimelineSvc () override=default
Public Member Functions inherited from extends< Service, ITimelineSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Member Functions
void | outputTimeline ()

## Private Attributes
Gaudi::Property< std::string > | m_timelineFile {this, "TimelineFile", "timeline.csv", ""}
Gaudi::Property< bool > | m_isEnabled {this, "RecordTimeline", false, "Enable recording of the timeline events"}
Gaudi::Property< bool > | m_dumpTimeline {this, "DumpTimeline", false, "Enable dumping of the timeline events"}
Gaudi::Property< bool > | m_partial {this, "Partial", false, ""}
tbb::concurrent_vector< TimelineEvent > | m_events

## Additional Inherited Members
Public Types inherited from extends< Service, ITimelineSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging ()
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 12 of file TimelineSvc.h.

## Constructor & Destructor Documentation

TimelineSvc::~TimelineSvc | ( |  | ) |
| override default

## Member Function Documentation

StatusCode TimelineSvc::finalize | ( |  | ) |
| override

Definition at line 42 of file TimelineSvc.cpp.

43 {
44
45 if ( m_dumpTimeline && m_events.size() > 0 ) {
46 MsgStream log( msgSvc(), name() );
47
48 log << MSG::INFO << "Outputting timeline with " << m_events.size() << " entries to file " << m_timelineFile
49 << endmsg;
50
51 outputTimeline();
52 }
53
54 return StatusCode::SUCCESS;
55 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
TimelineSvc::m_events
tbb::concurrent_vector< TimelineEvent > m_events
Definition: TimelineSvc.h:38
CommonMessagingBase::msgSvc
const SmartIF< IMessageSvc > & msgSvc() const
The standard message service.
Definition: CommonMessaging.h:75
TimelineSvc::m_timelineFile
Gaudi::Property< std::string > m_timelineFile
Definition: TimelineSvc.h:33
MSG::INFO
Definition: IMessageSvc.h:16
TimelineSvc::outputTimeline
void outputTimeline()
Definition: TimelineSvc.cpp:91
TimelineSvc::m_dumpTimeline
Gaudi::Property< bool > m_dumpTimeline
Definition: TimelineSvc.h:35
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
Gaudi.Configuration.log
log
Definition: Configuration.py:13

void TimelineSvc::getTimelineEvent | ( | TimelineEvent & | e | ) | const
| override

Definition at line 75 of file TimelineSvc.cpp.

76 {
77
78 for ( const auto& candidate : m_events ) {
79 if ( candidate.algorithm == e.algorithm && candidate.event == e.event && candidate.slot == e.slot ) {
80 e = candidate;
81 break;
82 }
83 }
84 }
TimelineEvent::algorithm
std::string algorithm
Definition: ITimelineSvc.h:18
TimelineEvent::event
uint event
Definition: ITimelineSvc.h:16
TimelineSvc::m_events
tbb::concurrent_vector< TimelineEvent > m_events
Definition: TimelineSvc.h:38
TimelineEvent::slot
uint slot
Definition: ITimelineSvc.h:15

StatusCode TimelineSvc::initialize | ( |  | ) |
| override

Definition at line 9 of file TimelineSvc.cpp.

10 {
11
12 StatusCode sc = Service::initialize();
13 if ( !sc.isSuccess() ) return sc;
14
15 if ( msgLevel( MSG::DEBUG ) ) debug() << "initialize" << endmsg;
16
17 m_events.clear();
18
19 if ( m_partial ) {
20 std::ofstream out( m_timelineFile + ".part", std::ofstream::trunc | std::ofstream::out );
21 out << "#start end algorithm thread slot event" << std::endl;
22 out.close();
23 }
24
25 return StatusCode::SUCCESS;
26 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
TimelineSvc::m_partial
Gaudi::Property< bool > m_partial
Definition: TimelineSvc.h:36
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:50
MSG::DEBUG
Definition: IMessageSvc.h:16
std::endl
T endl(T...args)
std::ofstream
STL class.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
TimelineSvc::m_events
tbb::concurrent_vector< TimelineEvent > m_events
Definition: TimelineSvc.h:38
TimelineSvc::m_timelineFile
Gaudi::Property< std::string > m_timelineFile
Definition: TimelineSvc.h:33
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:115
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the cached level (originally extracted from the embedded MsgStream)
Definition: CommonMessaging.h:124
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

bool TimelineSvc::isEnabled | ( |  | ) | const
| inline override

Definition at line 23 of file TimelineSvc.h.

23 { return m_isEnabled; }
TimelineSvc::m_isEnabled
Gaudi::Property< bool > m_isEnabled
Definition: TimelineSvc.h:34

void TimelineSvc::outputTimeline | ( |  | ) |
| private

Definition at line 91 of file TimelineSvc.cpp.

92 {
93
94 std::ofstream out( m_timelineFile, std::ofstream::out | std::ofstream::trunc );
95
96 out << "#start end algorithm thread slot event" << std::endl;
97
98 for ( const auto& e : m_events ) {
99 out << std::chrono::duration_cast<std::chrono::nanoseconds>( e.start.time_since_epoch() ).count() << " "
100 << std::chrono::duration_cast<std::chrono::nanoseconds>( e.end.time_since_epoch() ).count() << " "
101 << e.algorithm << " " << e.thread << " " << e.slot << " " << e.event << std::endl;
102 }
103
104 out.close();
105 }
std::chrono::nanoseconds
std::endl
T endl(T...args)
std::chrono::duration_cast
T duration_cast(T...args)
std::ofstream
STL class.
TimelineSvc::m_events
tbb::concurrent_vector< TimelineEvent > m_events
Definition: TimelineSvc.h:38
std::count
T count(T...args)
TimelineSvc::m_timelineFile
Gaudi::Property< std::string > m_timelineFile
Definition: TimelineSvc.h:33

void TimelineSvc::registerTimelineEvent | ( | const TimelineEvent & | e | ) |
| override

Definition at line 60 of file TimelineSvc.cpp.

61 {
62
63 m_events.push_back( e );
64
65 if ( m_partial ) {
66 std::ofstream out( m_timelineFile + ".part", std::ofstream::app | std::ofstream::out );
67 out << std::chrono::duration_cast<std::chrono::nanoseconds>( e.start.time_since_epoch() ).count() << " "
68 << std::chrono::duration_cast<std::chrono::nanoseconds>( e.end.time_since_epoch() ).count() << " "
69 << e.algorithm << " " << e.thread << " " << e.slot << " " << e.event << std::endl;
70
71 out.close();
72 }
73 }
std::chrono::nanoseconds
TimelineEvent::thread
pthread_t thread
Definition: ITimelineSvc.h:14
TimelineSvc::m_partial
Gaudi::Property< bool > m_partial
Definition: TimelineSvc.h:36
std::endl
T endl(T...args)
TimelineEvent::algorithm
std::string algorithm
Definition: ITimelineSvc.h:18
std::chrono::duration_cast
T duration_cast(T...args)
TimelineEvent::event
uint event
Definition: ITimelineSvc.h:16
TimelineEvent::end
time_point end
Definition: ITimelineSvc.h:21
std::ofstream
STL class.
TimelineSvc::m_events
tbb::concurrent_vector< TimelineEvent > m_events
Definition: TimelineSvc.h:38
std::count
T count(T...args)
TimelineEvent::start
time_point start
Definition: ITimelineSvc.h:20
TimelineSvc::m_timelineFile
Gaudi::Property< std::string > m_timelineFile
Definition: TimelineSvc.h:33
TimelineEvent::slot
uint slot
Definition: ITimelineSvc.h:15

StatusCode TimelineSvc::reinitialize | ( |  | ) |
| override

Definition at line 30 of file TimelineSvc.cpp.

31 {
32
33 MsgStream log( msgSvc(), name() );
34 log << MSG::DEBUG << "reinitialize" << endmsg;
35
36 m_events.clear();
37
38 return StatusCode::SUCCESS;
39 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
MSG::DEBUG
Definition: IMessageSvc.h:16
TimelineSvc::m_events
tbb::concurrent_vector< TimelineEvent > m_events
Definition: TimelineSvc.h:38
CommonMessagingBase::msgSvc
const SmartIF< IMessageSvc > & msgSvc() const
The standard message service.
Definition: CommonMessaging.h:75
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
Gaudi.Configuration.log
log
Definition: Configuration.py:13

## Member Data Documentation

Gaudi::Property<bool> TimelineSvc::m_dumpTimeline {this, "DumpTimeline", false, "Enable dumping of the timeline events"}
| private

Definition at line 35 of file TimelineSvc.h.

tbb::concurrent_vector<TimelineEvent> TimelineSvc::m_events
| private

Definition at line 38 of file TimelineSvc.h.

Gaudi::Property<bool> TimelineSvc::m_isEnabled {this, "RecordTimeline", false, "Enable recording of the timeline events"}
| private

Definition at line 34 of file TimelineSvc.h.

Gaudi::Property<bool> TimelineSvc::m_partial {this, "Partial", false, ""}
| private

Definition at line 36 of file TimelineSvc.h.

Gaudi::Property<std::string> TimelineSvc::m_timelineFile {this, "TimelineFile", "timeline.csv", ""}
| private

Definition at line 33 of file TimelineSvc.h.

The documentation for this class was generated from the following files:

- GaudiHive/src/TimelineSvc.h
- GaudiHive/src/TimelineSvc.cpp